<?php
/**
 * @version        3.5
 * @package        Joomla
 * @subpackage    Documents Seller
 * @author  Tuan Pham Ngoc
 * @copyright    Copyright (C) 2008 - 2013 Ossolution Team
 * @license        GNU/GPL, see LICENSE.php
 */
// no direct access
defined( '_JEXEC' ) or die();
JLoader::registerPrefix('DMS', JPATH_ROOT . '/components/com_dms');
function DMSBuildRoute(&$query)
{
    $segments = array();
    $db = JFactory::getDbo();
    $queryArr = $query;
    if (isset($queryArr['option']))
    {
        unset($queryArr['option']);
    }
    if (isset($queryArr['Itemid']))
    {
        unset($queryArr['Itemid']);
    }
    //Store the query string to use in the parseRouter method
    $queryString = http_build_query($queryArr);
    $app		= JFactory::getApplication();
    $menu		= $app->getMenu();
    $parentId = 0;
    //We need a menu item.  Either the one specified in the query, or the current active one if none specified
    if (empty($query['Itemid']))
    {
        $menuItem = $menu->getActive();

    }
    else
    {
        $menuItem = $menu->getItem($query['Itemid']);
    }
    if ($menuItem)
    {
        if (isset($menuItem->query['view']) && ($menuItem->query['view']== 'categories' || $menuItem->query['view'] == 'category'))
        {
			if (isset($menuItem->query['id']))
			{
				$parentId = (int)$menuItem->query['id'];
			}           
        }
    }
    if (empty($menuItem->query['view']))
    {
        $menuItem->query['view'] = '';
    }
    //Are we dealing with the current view which is attached to a menu item?
    if (($menuItem instanceof stdClass) && isset($query['view']) && isset($query['id']) && $menuItem->query['view'] == $query['view'] && isset($query['id']) && $menuItem->query['id'] == intval($query['id']))
    {
        unset($query['view']);
        if (isset($query['catid']))
        {
            unset($query['catid']);
        }
        unset($query['id']);
    }

    //Dealing with the catid parameter in the link to event.
    if (($menuItem instanceof stdClass) && ($menuItem->query['view'] == 'category') && isset($query['catid']) && $menuItem->query['id'] == intval($query['catid']))
    {
        if (isset($query['catid']))
        {
            unset($query['catid']);
        }
    }
    $view = isset($query['view']) ? $query['view'] : '';
    $id = 	isset($query['id']) ? (int) $query['id'] : 0;
    $catId = isset($query['catid']) ? (int) $query['catid'] : 0;
    $task = isset($query['task']) ? $query['task'] : '';
    switch ($view)
    {
        case 'categories':
        case 'category' :
            if ($id)
            {
                $segments = array_merge( $segments, DMSHelperRoute::getCategoriesPath($id, 'alias', true, $parentId));
            }
            unset($query['id']);
            break;
        case 'document' :
            if ($id)
            {
                $segments[] = DMSHelperRoute::getDocumentTitle($id);
            }
            unset($query['id']);
            if ($catId)
            {
                $segments = array_merge(DMSHelperRoute::getCategoriesPath($catId, 'alias', true, $parentId), $segments);
            }
            /*if (isset($query['layout']) && $query['layout'] == 'edit')
            {
                $segments[] = JText::_('EDOCMAN_SEF_EDIT');
                unset($query['layout']);
                break;
            }*/
            break;
        case 'checkout':
            $segments[] = JText::_('DMS_SEF_CHECKOUT');
            break;
        case 'search':
            $segments[] = JText::_('DMS_SEF_VIEW_SEARCH');
            break;
        case 'failure':
        case 'cancel':
        case 'complete':
            $segments[] = JText::_('DMS_SEF_ORDER_'.strtoupper($view));
            break;
    }

    switch($task)
    {
        case 'add_to_cart':
        case 'download':
            if ($id)
            {
                $segments[] = DMSHelperRoute::getDocumentTitle($id);
            }
            unset($query['id']);
            $segments[] = JText::_('DMS_SEF_'.strtoupper(str_replace('.', '_', $task)));
            unset($query['task']);
            break;
    }   
    if (isset($query['view']))
    {
        unset($query['view']);
    }
    if (isset($query['catid']))
    {
    	unset($query['catid']);
    }            
    if (count($segments))
    {
        $segments = array_map('JApplication::stringURLSafe', $segments);
        $key = md5(implode('/', $segments));
        $q = $db->getQuery(true);
        $q->select('COUNT(*)')
            ->from('#__dms_urls')
            ->where('md5_key="'.$key.'"');
        $db->setQuery($q);
        $total = $db->loadResult();
        if (!$total)
        {
            $q->clear();
            $q->insert('#__dms_urls')
                ->columns('md5_key, `query`')
                ->values("'$key', '$queryString'");
            $db->setQuery($q);
            $db->query();
        }
    }
	return $segments;
}

/**
 *
 * Parse the segments of a URL.
 * @param	array	The segments of the URL to parse.
 * @return	array	The URL attributes to be used by the application.
 */
function DMSParseRoute($segments)
{
	$vars = array();
	if (count($segments))
	{
		$db = JFactory::getDbo();
		$key = md5(str_replace(':', '-', implode('/', $segments)));
		$query = $db->getQuery(true);
		$query->select('`query`')
			->from('#__dms_urls')
			->where('md5_key="'.$key.'"');
		$db->setQuery($query);
		$queryString = $db->loadResult();
		if ($queryString)
		{
			parse_str(html_entity_decode($queryString), $vars);
		}			
	}
    $menu		= JFactory::getApplication()->getMenu();
	if ($item = $menu->getActive())
	{
		foreach ($item->query as $key=>$value)
		{
			if ($key != 'option' && $key != 'Itemid' && !isset($vars[$key]))
            {
                $vars[$key] = $value;
            }
		}
	}
	return $vars;
}